;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TIMERNT 1.0                                        ;;
;; (C) 2007 ᪮ ᥩ                            ;;
;;                                                    ;;
;; ࠩ, 騩 ᮡ ⠭ 㭪 BIOS ;;
;; AH=86 INT 15h (প). 㦭 ० ᥣ    ;;
;; 設  Windows XP  ᪠ DOS-ணࠬ, - ;;
;;    㭪 ( WinXP        ;;
;; ࠡ⠥,  ࠡ⠥   筮)        ;;
;;                                                    ;;
;; ᮡ                                         ;;
;; * ॡ   㦥 Intel Pentium        ;;
;; *  室  ( 256 )       ;;
;;     ᯮ짮 128   PSP            ;;
;;                                                    ;;
;;         GNU GPL v2       ;;
;;                                                    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;     Flat Assembler !!!  ;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;   ;;;;;

	org	100h			; code starts at offset 100h
	use16				; use 16-bit code

;;;;;  ;;;;;
word_ax_id = 06EDh
tail  = 080h        ;   PSP,    
shift = tail - 100h ;  ६ ⭮⥫쭮 ᥬ୮ ⨭

;;;;;    ;;;;;
start:	jmp init ; 室  楤 樠樨

;;; ࠡ稪 INT 15h ;;;
old_int15h dd 0 ; 祩  ࠭ ண 
new_int15h:     ; ࠡ稪 뢠 int 15h

	;  ࠡ稪 㭪樨 86h 
	; 室 
	; AH = 86h -  㭪樨
	; CX:DX    - ᫮ ᥪ㭤

	; ஢ઠ  㭪樨 BIOS
	cmp ah, 0FFh
	je inst_check

	cmp ah, 086h
	jne call_old_int

	; ࠭ ॣ஢
	pushad
	push ds

	; ⠭ ᥣ 
	push cs
	pop ds                        
	
	; ८ࠧ  CX:DX
	;  32- ࠧ來 ᫮ ( EAX)
	xor eax, eax  ;   EAX
	mov ax, dx    ;  
	mov dx, cx    ;   EDX  
	shl edx, 16   ;  襩 
	add eax, edx  ;  ᫮  ⥩ 

	call mksdelay ; প  ᥪ㭤

	; ⠭ ॣ஢  
	pop ds
	popad
	iret

	; 饭 䨪
inst_check:
	mov ax, word_ax_id
	iret

	; 맮 ண ࠡ稪
call_old_int:
	jmp dword ptr cs:(old_int15h+shift)


;;; 楤, 뢠 ࠡ稪 ;;;
; ⢨ প ⥫쭮  N ⠪⮢
; ⢮ ⠪⮢    ॣ஢ edx:eax
tickdelay:
	;  祭 ६ প
	mov ebx, eax
	mov ecx, edx

	;  ஢ 
	rdtsc
	mov [tick_start+shift  ], eax
	mov [tick_start+shift+4], edx

	;  প
td_cycle:
	rdtsc
	sub eax, [tick_start+shift]   ; ⠭ 襩 
	sbb edx, [tick_start+shift+4] ; ⠭ 襩 

	cmp edx, ecx ; ࠢ
	jb td_cycle  ; 襩 
	cmp eax, ebx ; ࠢ
	jbe td_cycle ; 襩 

	; 
	ret

; ⢨ প ⥫쭮  N ⠪⮢
; ᥪ㭤  室  EAX
mksdelay:
	; ॢ १  ⠪
	; ⢮ ⠪⮢ 㤥 室
	;   ॣ஢ edx:eax
	xor edx, edx
	mul dword [freq_MHZ+shift]
        	
	call tickdelay ; প  ⠪
	ret            ; 

;; ६ १⭮ 
tick_start  dd 0, 0 ; ६  ࠭ 砫 
freq_MHZ    dd 0    ;   

;;;;;    ;;;;;


;;;;;   ;;;;;
init:

	; 뢮 ଠ樮 ᮮ饭
	mov dx, hello
	call writestr

	; ஢ઠ ⠭
	mov ah, 0FFh ; 맮 㭪樨 ࠩ
	int 15h
	cmp ax, word_ax_id    ; ⠭?
	jne loader            ; ᫨  -   稪

	mov dx, txtfail       ; 뢮 ᮮ饭 "㦥  "
	call writestr
	int 20h               ; 

loader: ; ७ ணࠬ   PSP 
	; 㦭  ⨬樨 ᯮ짮 RAM
	;    256  :-)
	mov cx, init - 101h ;稪 横
cycle:	mov bx, cx   ; BX -  ਣ ࠧ
	mov si, cx   ; SI -  PSP
	add bx, 100h 
	add si, tail
	mov ah, [bx] ; ஢ 
	mov [si], ah ;  
	loop cycle
	;  ᫥ 
	mov ah, [100]  ; ஢ 
	mov [tail], ah ;  

	; ஢ থ  ⠩ BIOS
	call calibrate

	; ࠭  15h
	mov ax,3515h
	int 21h
	mov word ptr cs:(old_int15h  +shift), bx
	mov word ptr cs:(old_int15h+2+shift), es
	;   15h
	mov ax, 2515h
	mov dx, new_int15h+shift
	int 21h

	; 뢥  ࠭ ᮮ饭  ᯥ譮 ⠭
	mov	dx,txtok
	call writestr

	;  ணࠬ, ⠢  १⭮  
	mov ax, 3100h
	mov dx, (init-start+tail+15)/16
	int 21h

;;;;;   ;;;;;
; ஢ প 
; । ⠪⮢   
; । ᫠ ⠪⮢  ᥪ㭤
calibrate:

	pusha

	;  ᬥ 祭 ⠩ BIOS
	; 㦭  襭 筮
	push ds
	mov ax, 40h
	mov ds, ax
	mov eax, [6Ch]
bt_rst:	mov ebx, [6Ch]
	cmp eax, 0FFFFFFDFh ;  ਡ  । 稪?
	ja bt_rst           ; ᫨ ਡ - 릤
        cmp ebx, eax        ;  ந襫 "᪮" 稪?
	je bt_rst           ; ᫨  ந - 릤
	pop ds

	;  砫쭮 祭 稪 ⠪⮢
	rdtsc
	mov [tick_start+shift  ], eax
	mov [tick_start+shift+4], edx

	; 2. 뤥প 1 ᥪ	
	push ds
	mov ax,40h      ;   - 
	mov ds,ax       ;   BIOS (40h)
	mov eax, [6Ch]  ; 祩 ⠩
cbwait:	mov ebx, [6Ch]
	sub ebx, eax
	cmp ebx, 18
	jbe cbwait 
	pop ds

	;  筮 祭 稪 ⠪⮢
	rdtsc
	sub eax, [tick_start+shift]
	sbb edx, [tick_start+shift+4]

	mov ecx, 988659
	div ecx

	mov [freq_MHZ+shift], eax

	popa	
	ret 

; 楤  ப
;  ப -  ॣ ds:dx
writestr:
	mov ah, 09h
	int 21h
	ret

;;;;;   ;;;;;
hello   db 'TIMERNT 1.0',0Dh,0Ah
        db 'INT 15h AH=86h TSR EMULATOR',0Dh,0Ah
	db '(C) 2007 Voskov Alexey',0Dh,0Ah,'$'
txtfail db 'Emulator already loaded!$'
txtok   db 'Emulator successfully loaded!$'